UNIT mTAnwendung;

interface

uses   mSuM,MTQuadrat5;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        dieTastatur : Tastatur;
        aktivesQuadrat : TQuadrat;
        hatQuadrat1 : TQuadrat;
        hatQuadrat2 : TQuadrat;
        hatQuadrat3 : TQuadrat;
         //Objektbeziehungen:
        // hatTQuadrat1, // hatTQuadrat2, // hatTQuadrat3 : TQuadrat;
        // kenntTQuadrat : TQuadrat;

     // Methoden

     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieTastatur   := Tastatur.init;
  hatQuadrat1    := TQuadrat.init(50, 50, 50,dieMaus);
  hatQuadrat2    := TQuadrat.init(100,100,50,dieMaus);
  hatQuadrat3    := TQuadrat.init(150,150,50,dieMaus);
end;

//-------- run (public) ------------------------------------------------



procedure TAnwendung.run;
begin
  aktivesQuadrat := hatQuadrat1;
  hatQuadrat1.aktiviere;
  {aktivesQuadrat.aktiviere;}
 repeat

    if dieMaus.istGedrueckt then
    begin
          if hatQuadrat1.getroffen = true then
          begin
          hatQuadrat1.aktiviere;
          hatQuadrat2.deaktiviere;
          hatQuadrat3.deaktiviere;
          aktivesQuadrat := hatQuadrat1;
          end;



          if hatQuadrat2.getroffen = true then
          begin
          hatQuadrat2.aktiviere;
          hatQuadrat1.deaktiviere;
          hatQuadrat3.deaktiviere;
          aktivesQuadrat := hatQuadrat2;
          end;


          if hatQuadrat3.getroffen= true then
          begin
          hatQuadrat3.aktiviere;
          hatQuadrat1.deaktiviere;
          hatQuadrat2.deaktiviere;
          aktivesQuadrat := hatQuadrat3;
          end

    end;


   {if dieMaus.istGedrueckt then  // das zu aktivierende Quadrat bestimmen
    begin
      if NOT aktivesQuadrat wurde angeklickt then
        aktivesQuadrat.deaktiviere;
      if Quadrat1 wurde angeklickt then
        aktivesQuadrat := hatQuadrat1;
      if Quadrat2 wurde angeklickt then
        aktivesQuadrat := hatQuadrat2;
      if Quadrat3 wurde angeklickt then
        aktivesQuadrat := hatQuadrat3;
      aktivesQuadrat.aktiviere;
    end;    }

    if dieTastatur.wurdeGedrueckt then  // Tastendruck auswerten
    begin
      case dieTastatur.zeichen of
        PFEILOBEN   : aktivesQuadrat.Bewegeum (Pfeiloben);
        PFEILUNTEN  : aktivesQuadrat.Bewegeum (Pfeilunten);
        PFEILRECHTS : aktivesQuadrat.Bewegeum (Pfeilrechts);
        PFEILLINKS : aktivesQuadrat.Bewegeum (Pfeillinks);
        '1' : aktivesQuadrat.setzeGroesse (20);
        '2' : aktivesQuadrat.setzeGroesse (40);
        '3' : aktivesQuadrat.setzeGroesse (60);
        '4' : aktivesQuadrat.setzeGroesse (80);
        '5' : aktivesQuadrat.setzeGroesse (100);
        '6' : aktivesQuadrat.setzeGroesse (120);
        '7' : aktivesQuadrat.setzeGroesse (140);
        '8' : aktivesQuadrat.setzeGroesse (160);
        '9' : aktivesQuadrat.setzeGroesse (180);
        'r' : aktivesQuadrat.setzeFarbe(rot);
        's' : aktivesQuadrat.setzeFarbe (schwarz);
        'g' : aktivesQuadrat.setzeFarbe (gruen);
        'b' : aktivesQuadrat.setzeFarbe (blau);
        { usw
           .
           .
           .
         }

      end;
      hatQuadrat1.zeichne;
      hatQuadrat2.zeichne;
      hatQuadrat3.zeichne;
      dieTastatur.weiter
    end
  until dieMaus.doppelklick;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  hatQuadrat3.gibFrei;
  hatQuadrat2.gibFrei;
  hatQuadrat1.gibFrei;
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
