UNIT mTRechteck;

interface

uses    msum;
// Uses-Klausel ggf. anpassen

type
   TRechteck = CLASS

     // Attribute
     private
        istAktiv : Boolean;
        meinBuntStift : Buntstift;
        meineMaus : Maus;
        meineTastatur : Tastatur;
        breite : zahl;
        hoehe : zahl;
        xPos : zahl;
        yPos : zahl;
        farbe : zeichen;

     // Methoden
     public
        constructor init(pXPos,pYPos,pGroesse:zahl; pMaus: Maus);
        procedure aktiviere;
        procedure bewegeBis(xbis,ybis:Zahl);
        procedure bewegeUm(strecke:Zahl);
        procedure deaktiviere;
        procedure setzeFarbe(farbe:Zeichen);
        procedure setzeGroesse(faktor:zahl);
        procedure zeichne;
        function getroffen : Boolean;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteck: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TRechteck.init(pXPos,pYPos,pGroesse:zahl; pMaus: Maus);
begin
  meinBuntStift := BuntStift.init;
  xPos := pxPos;
  yPos := pyPos;
  breite := pgroesse * 1.4;
  hoehe  := pgroesse;
  meineMaus := pMaus;
  self.zeichne;
end;

//-------- aktiviere (public) ------------------------------------------
procedure TRechteck.aktiviere;
begin
   MeinBuntstift.setzeLinienBreite (4);
   self.zeichne;
end;

//-------- bewegeBis (public) ------------------------------------------
procedure TRechteck.bewegeBis(xbis,ybis:Zahl);
begin
  //Hier Code einfgen.
end;

//-------- bewegeUm (public) -------------------------------------------
procedure TRechteck.bewegeUm(strecke:Zahl);
begin
  //Hier Code einfgen.
end;

//-------- deaktiviere (public) ----------------------------------------
procedure TRechteck.deaktiviere;
begin
   { hier erst dickes Rechteck lschen !!!!!!!!!!!!!!!!!!!!!!!!!11}
   MeinBuntstift.setzeLinienBreite (1);
   self.zeichne;
end;

//-------- setzeFarbe (public) -----------------------------------------
procedure TRechteck.setzeFarbe(farbe:Zeichen);
begin
   farbe := meineTastatur.zeichen;
   self.zeichne;
end;

//-------- setzeGroesse (public) ---------------------------------------
procedure TRechteck.setzeGroesse(faktor:zahl);
begin
  //Hier Code einfgen.
end;

//-------- zeichne (public) --------------------------------------------
procedure TRechteck.zeichne;
begin
   meinBuntStift.BewegeBis (xPos, yPos);
   meinBuntStift.SetzeFarbe (Ord(farbe));
   meinBuntStift.zeichneRechteck (breite, hoehe);
end;

//-------- getroffen (public) ------------------------------------------
function TRechteck.getroffen: Boolean;
begin
   getroffen := meineMaus.istGedrueckt
                AND (meineMaus.hPosition > xPos)
                AND (meineMaus.hPosition < xPos + breite)
                AND (meineMaus.vPosition > yPos)
                AND (meineMaus.vPosition < yPos + hoehe)
end;

//-------- gibFrei (public) --------------------------------------------
destructor TRechteck.gibFrei;
begin
  //Hier Code einfgen.
end;

end.
