UNIT mTAnwendung;

interface

uses  mSuM,MTKreis;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        dieTastatur : Tastatur;
        aktiverKreis : TKreis;
        hatKreis1 : TKreis;
        hatKreis2 : TKreis;
        hatKreis3 : TKreis;

     //Objektbeziehungen:
        // hatKreis1, // hatKreis2, // hatKreis3 : Kreis;
        // kenntKreis : Kreis;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieTastatur   := Tastatur.init;
  hatKreis1    := TKreis.init(....);
  hatKreis2    := TKreis.init(....);
  hatKreis3    := TKreis.init(....);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
  aktiverKreis := hatKreis1;
  aktiverKreis.aktiviere;
  repeat
    if dieMaus.istGedrueckt then  // den zu aktivierenden Kreis bestimmen
    begin
      if NOT aktiverKreis wurde angeklickt then
        aktiverKreis.deaktiviere;
      if Kreis1 wurde angeklickt then
        aktiverKreis := hatKreis1;
      if Kreis2 wurde angeklickt then
        aktiverKreis := hatKreis2;
      if Kreis3 wurde angeklickt then
        aktiverKreis := hatKreis3;
      aktiverKreis.aktiviere;
    end;

    if dieTastatur.wurdeGedrueckt then  // Tastendruck auswerten
    begin
      case dieTastatur.zeichen of
        PFEILOBEN   : bewege aktiven Kreis nach oben
        { usw
           .
           .
           .
         }
      end;
      dieTastatur.weiter
    end
  until dieMaus.doppelklick;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  hatKreis3.gibFrei;
  hatKreis2.gibFrei;
  hatKreis1.gibFrei;
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
