UNIT mTAnwendung5;

interface

uses   mSuM, MTQuadrat5,mTKreis,mTFigur;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        dieTastatur : Tastatur;
        aktiveFigur : TFigur;
        hatQuadrat1 : TQuadrat;
        hatQuadrat2 : TQuadrat;
        hatQuadrat3 : TQuadrat;
        hatKreis    : TKreis;
         //Objektbeziehungen:
        // hatTQuadrat1, // hatTQuadrat2, // hatTQuadrat3 : TQuadrat;
        // kenntTQuadrat : TQuadrat;

     // Methoden

     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieTastatur   := Tastatur.init;
  hatQuadrat1    := TQuadrat.init(50, 50, 50,dieMaus);
  hatQuadrat2    := TQuadrat.init(100,100,50,dieMaus);
  hatQuadrat3    := TQuadrat.init(150,150,50,dieMaus);
  hatKreis       := TKreis.init(200,200,50,dieMaus);

end;

//-------- run (public) ------------------------------------------------



procedure TAnwendung.run;
begin
  aktiveFigur := hatQuadrat1;
  hatQuadrat1.aktiviere;
  {aktiveFigur.aktiviere;}
 repeat

    if dieMaus.istGedrueckt then
    begin
          if hatQuadrat1.getroffen = true then
          begin
          hatQuadrat1.aktiviere;
          hatQuadrat2.deaktiviere;
          hatQuadrat3.deaktiviere;
          hatKreis.deaktiviere;
          aktiveFigur := hatQuadrat1;
          end;



          if hatQuadrat2.getroffen = true then
          begin
          hatQuadrat2.aktiviere;
          hatQuadrat1.deaktiviere;
          hatQuadrat3.deaktiviere;
          hatKreis.deaktiviere;
          aktiveFigur := hatQuadrat2;
          end;


          if hatQuadrat3.getroffen= true then
          begin
          hatQuadrat3.aktiviere;
          hatQuadrat1.deaktiviere;
          hatQuadrat2.deaktiviere;
          hatKreis.deaktiviere;
          aktiveFigur := hatQuadrat3;
          end;

          if hatKreis.getroffen= true then
          begin
          hatKreis.aktiviere;
          hatQuadrat1.deaktiviere;
          hatQuadrat2.deaktiviere;
          hatQuadrat3.deaktiviere;
          aktiveFigur := hatKreis;
          end

    end;


   {if dieMaus.istGedrueckt then  // das zu aktivierende Quadrat bestimmen
    begin
      if NOT aktiveFigur wurde angeklickt then
        aktiveFigur.deaktiviere;
      if Quadrat1 wurde angeklickt then
        aktiveFigur := hatQuadrat1;
      if Quadrat2 wurde angeklickt then
        aktiveFigur := hatQuadrat2;
      if Quadrat3 wurde angeklickt then
        aktiveFigur := hatQuadrat3;
      aktiveFigur.aktiviere;
    end;    }

    if dieTastatur.wurdeGedrueckt then  // Tastendruck auswerten
    begin
      case dieTastatur.zeichen of
        PFEILOBEN   : aktiveFigur.Bewegeum (Pfeiloben);
        PFEILUNTEN  : aktiveFigur.Bewegeum (Pfeilunten);
        PFEILRECHTS : aktiveFigur.Bewegeum (Pfeilrechts);
        PFEILLINKS : aktiveFigur.Bewegeum (Pfeillinks);
        '1' : aktiveFigur.setzeGroesse (20);
        '2' : aktiveFigur.setzeGroesse (40);
        '3' : aktiveFigur.setzeGroesse (60);
        '4' : aktiveFigur.setzeGroesse (80);
        '5' : aktiveFigur.setzeGroesse (100);
        '6' : aktiveFigur.setzeGroesse (120);
        '7' : aktiveFigur.setzeGroesse (140);
        '8' : aktiveFigur.setzeGroesse (160);
        '9' : aktiveFigur.setzeGroesse (180);
        'r' : aktiveFigur.setzeFarbe(rot);
        's' : aktiveFigur.setzeFarbe (schwarz);
        'g' : aktiveFigur.setzeFarbe (gruen);
        'b' : aktiveFigur.setzeFarbe (blau);
        { usw
           .
           .
           .
         }

      end;
      hatQuadrat1.zeichne;
      hatQuadrat2.zeichne;
      hatQuadrat3.zeichne;
      hatKreis.zeichne;
      dieTastatur.weiter
    end
  until dieMaus.doppelklick;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  hatKreis.gibFrei;
  hatQuadrat3.gibFrei;
  hatQuadrat2.gibFrei;
  hatQuadrat1.gibFrei;
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
