UNIT mTDreieck;

interface

uses  mSuM, mTFigur;
// Uses-Klausel ggf. anpassen

type
   TDreieck = CLASS(TFigur)

     // Attribute

     // Methoden
     public
        procedure zeichne; override;
        function getroffen(pHPosition,pVPosition:Zahl) : Wahrheitswert; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TDreieck: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (public) --------------------------------------------
procedure TDreieck.zeichne;
begin
  hatStift.runter;
  hatStift.bewegeUm(zGroesse);
  hatStift.dreheUm(135);
  hatStift.bewegeUm(zGroesse * 1.4142135624);
  hatStift.dreheUm(135);
  hatStift.bewegeUm(zGroesse);
  hatStift.dreheUm(90);
  hatStift.hoch
end;

//-------- getroffen (public) ------------------------------------------
function TDreieck.getroffen(pHPosition,pVPosition:Zahl) : Wahrheitswert;
begin
  result := (pHPosition >= self.hPosition) and
            (pVPosition <= self.vPosition) and
            ((pHPosition - self.hPosition) - (pVPosition - self.vPosition) <= zGroesse)
end;

end.
