UNIT mTRechteck;

interface

uses   mSuM, mTFigur;
// Uses-Klausel ggf. anpassen

type
   TRechteck = CLASS(TFigur)

     // Attribute
     public
        zBreite : Zahl;

     // Methoden
     public
        constructor init(pHPosition,pVPosition,pGroesse,pBreite:Zahl); overload;
        procedure setzeBreite(pBreite:Zahl);
        procedure zeichne; override;
        function breite : Zahl;
        function getroffen(pHPosition,pVPosition:Zahl) : Wahrheitswert; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteck: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TRechteck.init(pHPosition,pVPosition,pGroesse,pBreite:Zahl);
begin
  zBreite := pBreite;
  inherited init(pHPosition, pVPosition, pGroesse);
end;

//-------- setzeBreite (public) ----------------------------------------
procedure TRechteck.setzeBreite(pBreite:Zahl);
begin
  self.loesche;
  zBreite := pBreite;
  self.zeichne;
end;

//-------- zeichne (public) --------------------------------------------
procedure TRechteck.zeichne;
begin
  hatStift.zeichneRechteck(zBreite,zGroesse)
end;

//-------- breite (public) ---------------------------------------------
function TRechteck.breite : Zahl;
begin
  result := zBreite;
end;

//-------- getroffen (public) ------------------------------------------
function TRechteck.getroffen(pHPosition,pVPosition:Zahl) : Wahrheitswert;
begin
  result := (pHPosition >= self.hPosition) and
            (pVPosition >= self.vPosition) and
            (pHPosition <= self.hPosition + zBreite) and
            (pVPosition <= self.vPosition + zGroesse)
end;

end.
